background?: boolean | null

Body param: Whether to run the model response in the background. Learn more.

context_management?: Array<ContextManagement> | null

Body param: Context management configuration for this request.

type: string

The context management entry type. Currently only ‘compaction’ is supported.

compact_threshold?: number | null

Token threshold at which compaction should be triggered for this entry.

minimum1000
conversation?: string | BetaResponseConversationParam { id } | null

Body param: The conversation that this response belongs to. Items from this conversation are prepended to input_items for this response request. Input items and output items from this response are automatically added to this conversation after this response completes.

One of the following:
string
BetaResponseConversationParam { id }

The conversation that this response belongs to.

id: string

The unique ID of the conversation.

include?: Array<BetaResponseIncludable> | null

Body param: Specify additional output data to include in the model response. Currently supported values are:

  • web_search_call.action.sources: Include the sources of the web search tool call.
  • code_interpreter_call.outputs: Includes the outputs of python code execution in code interpreter tool call items.
  • computer_call_output.output.image_url: Include image urls from the computer call output.
  • file_search_call.results: Include the search results of the file search tool call.
  • message.input_image.image_url: Include image urls from the input message.
  • message.output_text.logprobs: Include logprobs with assistant messages.
  • reasoning.encrypted_content: Includes an encrypted version of reasoning tokens in reasoning item outputs. This enables reasoning items to be used in multi-turn conversations when using the Responses API statelessly (like when the store parameter is set to false, or when an organization is enrolled in the zero data retention program).
One of the following:
"file_search_call.results"
"web_search_call.results"
"web_search_call.action.sources"
"message.input_image.image_url"
"computer_call_output.output.image_url"
"code_interpreter_call.outputs"
"reasoning.encrypted_content"
"message.output_text.logprobs"
input?: string | BetaResponseInput { , , , 33 more }

Body param: Text, image, or file inputs to the model, used to generate a response.

Learn more:

One of the following:
string
BetaResponseInput = Array<BetaResponseInputItem>

A list of one or many input items to the model, containing different content types.

One of the following:
BetaEasyInputMessage { content, role, phase, type }

A message input to the model with a role indicating instruction following hierarchy. Instructions given with the developer or system role take precedence over instructions given with the user role. Messages with the assistant role are presumed to have been generated by the model in previous interactions.

content: string | BetaResponseInputMessageContentList { , , }

Text, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses.

One of the following:
string
BetaResponseInputMessageContentList = Array<BetaResponseInputContent>

A list of one or many input items to the model, containing different content types.

One of the following:
BetaResponseInputText { text, type, prompt_cache_breakpoint }

A text input to the model.

text: string

The text input to the model.

type: "input_text"

The type of the input item. Always input_text.

prompt_cache_breakpoint?: PromptCacheBreakpoint { mode }

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputImage { detail, type, file_id, 2 more }

An image input to the model. Learn about image inputs.

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

One of the following:
"low"
"high"
"auto"
"original"
type: "input_image"

The type of the input item. Always input_image.

file_id?: string | null

The ID of the file to be sent to the model.

image_url?: string | null

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

formaturi
prompt_cache_breakpoint?: PromptCacheBreakpoint { mode }

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputFile { type, detail, file_data, 4 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail?: "auto" | "low" | "high"

The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.

One of the following:
"auto"
"low"
"high"
file_data?: string

The content of the file to be sent to the model.

file_id?: string | null

The ID of the file to be sent to the model.

file_url?: string

The URL of the file to be sent to the model.

formaturi
filename?: string

The name of the file to be sent to the model.

prompt_cache_breakpoint?: PromptCacheBreakpoint { mode }

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

role: "user" | "assistant" | "system" | "developer"

The role of the message input. One of user, assistant, system, or developer.

One of the following:
"user"
"assistant"
"system"
"developer"
phase?: "commentary" | "final_answer" | null

Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.

One of the following:
"commentary"
"final_answer"
type?: "message"

The type of the message input. Always message.

Message { content, role, agent, 2 more }

A message input to the model with a role indicating instruction following hierarchy. Instructions given with the developer or system role take precedence over instructions given with the user role.

A list of one or many input items to the model, containing different content types.

One of the following:
BetaResponseInputText { text, type, prompt_cache_breakpoint }

A text input to the model.

text: string

The text input to the model.

type: "input_text"

The type of the input item. Always input_text.

prompt_cache_breakpoint?: PromptCacheBreakpoint { mode }

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputImage { detail, type, file_id, 2 more }

An image input to the model. Learn about image inputs.

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

One of the following:
"low"
"high"
"auto"
"original"
type: "input_image"

The type of the input item. Always input_image.

file_id?: string | null

The ID of the file to be sent to the model.

image_url?: string | null

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

formaturi
prompt_cache_breakpoint?: PromptCacheBreakpoint { mode }

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputFile { type, detail, file_data, 4 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail?: "auto" | "low" | "high"

The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.

One of the following:
"auto"
"low"
"high"
file_data?: string

The content of the file to be sent to the model.

file_id?: string | null

The ID of the file to be sent to the model.

file_url?: string

The URL of the file to be sent to the model.

formaturi
filename?: string

The name of the file to be sent to the model.

prompt_cache_breakpoint?: PromptCacheBreakpoint { mode }

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

role: "user" | "system" | "developer"

The role of the message input. One of user, system, or developer.

One of the following:
"user"
"system"
"developer"
agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

status?: "in_progress" | "completed" | "incomplete"

The status of item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

One of the following:
"in_progress"
"completed"
"incomplete"
type?: "message"

The type of the message input. Always set to message.

BetaResponseOutputMessage { id, content, role, 4 more }

An output message from the model.

id: string

The unique ID of the output message.

content: Array<BetaResponseOutputText { annotations, text, type, logprobs } | BetaResponseOutputRefusal { refusal, type } >

The content of the output message.

One of the following:
BetaResponseOutputText { annotations, text, type, logprobs }

A text output from the model.

annotations: Array<FileCitation { file_id, filename, index, type } | URLCitation { end_index, start_index, title, 2 more } | ContainerFileCitation { container_id, end_index, file_id, 3 more } | FilePath { file_id, index, type } >

The annotations of the text output.

One of the following:
FileCitation { file_id, filename, index, type }

A citation to a file.

file_id: string

The ID of the file.

filename: string

The filename of the file cited.

index: number

The index of the file in the list of files.

type: "file_citation"

The type of the file citation. Always file_citation.

URLCitation { end_index, start_index, title, 2 more }

A citation for a web resource used to generate a model response.

end_index: number

The index of the last character of the URL citation in the message.

start_index: number

The index of the first character of the URL citation in the message.

title: string

The title of the web resource.

type: "url_citation"

The type of the URL citation. Always url_citation.

url: string

The URL of the web resource.

formaturi
ContainerFileCitation { container_id, end_index, file_id, 3 more }

A citation for a container file used to generate a model response.

container_id: string

The ID of the container file.

end_index: number

The index of the last character of the container file citation in the message.

file_id: string

The ID of the file.

filename: string

The filename of the container file cited.

start_index: number

The index of the first character of the container file citation in the message.

type: "container_file_citation"

The type of the container file citation. Always container_file_citation.

FilePath { file_id, index, type }

A path to a file.

file_id: string

The ID of the file.

index: number

The index of the file in the list of files.

type: "file_path"

The type of the file path. Always file_path.

text: string

The text output from the model.

type: "output_text"

The type of the output text. Always output_text.

logprobs?: Array<Logprob>
token: string
bytes: Array<number>
logprob: number
top_logprobs: Array<TopLogprob>
token: string
bytes: Array<number>
logprob: number
BetaResponseOutputRefusal { refusal, type }

A refusal from the model.

refusal: string

The refusal explanation from the model.

type: "refusal"

The type of the refusal. Always refusal.

role: "assistant"

The role of the output message. Always assistant.

status: "in_progress" | "completed" | "incomplete"

The status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API.

One of the following:
"in_progress"
"completed"
"incomplete"
type: "message"

The type of the output message. Always message.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

phase?: "commentary" | "final_answer" | null

Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.

One of the following:
"commentary"
"final_answer"
BetaResponseFileSearchToolCall { id, queries, status, 3 more }

The results of a file search tool call. See the file search guide for more information.

id: string

The unique ID of the file search tool call.

queries: Array<string>

The queries used to search for files.

status: "in_progress" | "searching" | "completed" | 2 more

The status of the file search tool call. One of in_progress, searching, incomplete or failed,

One of the following:
"in_progress"
"searching"
"completed"
"incomplete"
"failed"
type: "file_search_call"

The type of the file search tool call. Always file_search_call.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

results?: Array<Result> | null

The results of the file search tool call.

attributes?: Record<string, string | number | boolean> | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers.

One of the following:
string
number
boolean
file_id?: string

The unique ID of the file.

filename?: string

The name of the file.

score?: number

The relevance score of the file - a value between 0 and 1.

formatfloat
text?: string

The text that was retrieved from the file.

BetaResponseComputerToolCall { id, call_id, pending_safety_checks, 5 more }

A tool call to a computer use tool. See the computer use guide for more information.

id: string

The unique ID of the computer call.

call_id: string

An identifier used when responding to the tool call with output.

pending_safety_checks: Array<PendingSafetyCheck>

The pending safety checks for the computer call.

id: string

The ID of the pending safety check.

code?: string | null

The type of the pending safety check.

message?: string | null

Details about the pending safety check.

status: "in_progress" | "completed" | "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

One of the following:
"in_progress"
"completed"
"incomplete"
type: "computer_call"

The type of the computer call. Always computer_call.

A click action.

One of the following:
Click { button, type, x, 2 more }

A click action.

button: "left" | "right" | "wheel" | 2 more

Indicates which mouse button was pressed during the click. One of left, right, wheel, back, or forward.

One of the following:
"left"
"right"
"wheel"
"back"
"forward"
type: "click"

Specifies the event type. For a click action, this property is always click.

x: number

The x-coordinate where the click occurred.

y: number

The y-coordinate where the click occurred.

keys?: Array<string> | null

The keys being held while clicking.

DoubleClick { keys, type, x, y }

A double click action.

keys: Array<string> | null

The keys being held while double-clicking.

type: "double_click"

Specifies the event type. For a double click action, this property is always set to double_click.

x: number

The x-coordinate where the double click occurred.

y: number

The y-coordinate where the double click occurred.

Drag { path, type, keys }

A drag action.

path: Array<Path>

An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg

[
  { x: 100, y: 200 },
  { x: 200, y: 300 }
]
x: number

The x-coordinate.

y: number

The y-coordinate.

type: "drag"

Specifies the event type. For a drag action, this property is always set to drag.

keys?: Array<string> | null

The keys being held while dragging the mouse.

Keypress { keys, type }

A collection of keypresses the model would like to perform.

keys: Array<string>

The combination of keys the model is requesting to be pressed. This is an array of strings, each representing a key.

type: "keypress"

Specifies the event type. For a keypress action, this property is always set to keypress.

Move { type, x, y, keys }

A mouse move action.

type: "move"

Specifies the event type. For a move action, this property is always set to move.

x: number

The x-coordinate to move to.

y: number

The y-coordinate to move to.

keys?: Array<string> | null

The keys being held while moving the mouse.

Screenshot { type }

A screenshot action.

type: "screenshot"

Specifies the event type. For a screenshot action, this property is always set to screenshot.

Scroll { scroll_x, scroll_y, type, 3 more }

A scroll action.

scroll_x: number

The horizontal scroll distance.

scroll_y: number

The vertical scroll distance.

type: "scroll"

Specifies the event type. For a scroll action, this property is always set to scroll.

x: number

The x-coordinate where the scroll occurred.

y: number

The y-coordinate where the scroll occurred.

keys?: Array<string> | null

The keys being held while scrolling.

Type { text, type }

An action to type in text.

text: string

The text to type.

type: "type"

Specifies the event type. For a type action, this property is always set to type.

Wait { type }

A wait action.

type: "wait"

Specifies the event type. For a wait action, this property is always set to wait.

actions?: BetaComputerActionList { , , , 6 more }

Flattened batched actions for computer_use. Each action includes an type discriminator and action-specific fields.

One of the following:
Click { button, type, x, 2 more }

A click action.

button: "left" | "right" | "wheel" | 2 more

Indicates which mouse button was pressed during the click. One of left, right, wheel, back, or forward.

One of the following:
"left"
"right"
"wheel"
"back"
"forward"
type: "click"

Specifies the event type. For a click action, this property is always click.

x: number

The x-coordinate where the click occurred.

y: number

The y-coordinate where the click occurred.

keys?: Array<string> | null

The keys being held while clicking.

DoubleClick { keys, type, x, y }

A double click action.

keys: Array<string> | null

The keys being held while double-clicking.

type: "double_click"

Specifies the event type. For a double click action, this property is always set to double_click.

x: number

The x-coordinate where the double click occurred.

y: number

The y-coordinate where the double click occurred.

Drag { path, type, keys }

A drag action.

path: Array<Path>

An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg

[
  { x: 100, y: 200 },
  { x: 200, y: 300 }
]
x: number

The x-coordinate.

y: number

The y-coordinate.

type: "drag"

Specifies the event type. For a drag action, this property is always set to drag.

keys?: Array<string> | null

The keys being held while dragging the mouse.

Keypress { keys, type }

A collection of keypresses the model would like to perform.

keys: Array<string>

The combination of keys the model is requesting to be pressed. This is an array of strings, each representing a key.

type: "keypress"

Specifies the event type. For a keypress action, this property is always set to keypress.

Move { type, x, y, keys }

A mouse move action.

type: "move"

Specifies the event type. For a move action, this property is always set to move.

x: number

The x-coordinate to move to.

y: number

The y-coordinate to move to.

keys?: Array<string> | null

The keys being held while moving the mouse.

Screenshot { type }

A screenshot action.

type: "screenshot"

Specifies the event type. For a screenshot action, this property is always set to screenshot.

Scroll { scroll_x, scroll_y, type, 3 more }

A scroll action.

scroll_x: number

The horizontal scroll distance.

scroll_y: number

The vertical scroll distance.

type: "scroll"

Specifies the event type. For a scroll action, this property is always set to scroll.

x: number

The x-coordinate where the scroll occurred.

y: number

The y-coordinate where the scroll occurred.

keys?: Array<string> | null

The keys being held while scrolling.

Type { text, type }

An action to type in text.

text: string

The text to type.

type: "type"

Specifies the event type. For a type action, this property is always set to type.

Wait { type }

A wait action.

type: "wait"

Specifies the event type. For a wait action, this property is always set to wait.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

ComputerCallOutput { call_id, output, type, 4 more }

The output of a computer tool call.

call_id: string

The ID of the computer tool call that produced the output.

minLength1
maxLength64
output: BetaResponseComputerToolCallOutputScreenshot { type, file_id, image_url }

A computer screenshot image used with the computer use tool.

type: "computer_screenshot"

Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.

file_id?: string

The identifier of an uploaded file that contains the screenshot.

image_url?: string

The URL of the screenshot image.

formaturi
type: "computer_call_output"

The type of the computer tool call output. Always computer_call_output.

id?: string | null

The ID of the computer tool call output.

acknowledged_safety_checks?: Array<AcknowledgedSafetyCheck> | null

The safety checks reported by the API that have been acknowledged by the developer.

id: string

The ID of the pending safety check.

code?: string | null

The type of the pending safety check.

message?: string | null

Details about the pending safety check.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

status?: "in_progress" | "completed" | "incomplete" | null

The status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API.

One of the following:
"in_progress"
"completed"
"incomplete"
One of the following:
One of the following:
BetaResponseFunctionToolCall { arguments, call_id, name, 7 more }

A tool call to run a function. See the function calling guide for more information.

arguments: string

A JSON string of the arguments to pass to the function.

call_id: string

The unique ID of the function tool call generated by the model.

name: string

The name of the function to run.

type: "function_call"

The type of the function tool call. Always function_call.

id?: string

The unique ID of the function tool call.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

async?: boolean

Whether the function tool call runs asynchronously.

caller?: Direct { type } | Program { caller_id, type } | null

The execution context that produced this tool call.

One of the following:
Direct { type }
type: "direct"
Program { caller_id, type }
caller_id: string

The call ID of the program item that produced this tool call.

type: "program"
namespace?: string

The namespace of the function to run.

status?: "in_progress" | "completed" | "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

One of the following:
"in_progress"
"completed"
"incomplete"
FunctionCallOutput { output, type, id, 6 more }

The output of a function tool call.

output: string | BetaResponseFunctionCallOutputItemList { , , }

Text, image, or file output of the function tool call.

One of the following:
string
BetaResponseFunctionCallOutputItemList = Array<BetaResponseFunctionCallOutputItem>

An array of content outputs (text, image, file) for the function tool call.

One of the following:
BetaResponseInputTextContent { text, type, prompt_cache_breakpoint }

A text input to the model.

text: string

The text input to the model.

maxLength10485760
type: "input_text"

The type of the input item. Always input_text.

prompt_cache_breakpoint?: PromptCacheBreakpoint | null

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputImageContent { type, detail, file_id, 2 more }

An image input to the model. Learn about image inputs

type: "input_image"

The type of the input item. Always input_image.

detail?: BetaImageDetail | null

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

One of the following:
"low"
"high"
"auto"
"original"
file_id?: string | null

The ID of the file to be sent to the model.

image_url?: string | null

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

maxLength20971520
formaturi
prompt_cache_breakpoint?: PromptCacheBreakpoint | null

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputFileContent { type, detail, file_data, 4 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail?: "auto" | "low" | "high"

The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.

One of the following:
"auto"
"low"
"high"
file_data?: string | null

The base64-encoded data of the file to be sent to the model.

maxLength73400320
file_id?: string | null

The ID of the file to be sent to the model.

file_url?: string | null

The URL of the file to be sent to the model.

formaturi
filename?: string | null

The name of the file to be sent to the model.

prompt_cache_breakpoint?: PromptCacheBreakpoint | null

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

type: "function_call_output"

The type of the function tool call output. Always function_call_output.

id?: string | null

The unique ID of the function tool call output. Populated when this item is returned via API.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

call_id?: string | null

The unique ID of the function tool call generated by the model.

minLength1
maxLength64
caller?: Direct { type } | Program { caller_id, type } | null

The execution context that produced this tool call.

One of the following:
Direct { type }
type: "direct"

The caller type. Always direct.

Program { caller_id, type }
caller_id: string

The call ID of the program item that produced this tool call.

minLength1
maxLength64
type: "program"

The caller type. Always program.

name?: string | null

The name of the tool that produced the output.

minLength1
maxLength128
namespace?: string | null

The namespace of the tool that produced the output.

minLength1
maxLength64
status?: "in_progress" | "completed" | "incomplete" | null

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

One of the following:
"in_progress"
"completed"
"incomplete"
AgentMessage { author, content, recipient, 3 more }

A message routed between agents.

author: string

The sending agent identity.

content: Array<BetaResponseInputTextContent { text, type, prompt_cache_breakpoint } | BetaResponseInputImageContent { type, detail, file_id, 2 more } | EncryptedContent { encrypted_content, type } >

Plaintext, image, or encrypted content sent between agents.

One of the following:
BetaResponseInputTextContent { text, type, prompt_cache_breakpoint }

A text input to the model.

text: string

The text input to the model.

maxLength10485760
type: "input_text"

The type of the input item. Always input_text.

prompt_cache_breakpoint?: PromptCacheBreakpoint | null

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

BetaResponseInputImageContent { type, detail, file_id, 2 more }

An image input to the model. Learn about image inputs

type: "input_image"

The type of the input item. Always input_image.

detail?: BetaImageDetail | null

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

One of the following:
"low"
"high"
"auto"
"original"
file_id?: string | null

The ID of the file to be sent to the model.

image_url?: string | null

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

maxLength20971520
formaturi
prompt_cache_breakpoint?: PromptCacheBreakpoint | null

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode: "explicit"

The breakpoint mode. Always explicit.

EncryptedContent { encrypted_content, type }

Opaque encrypted content that Responses API decrypts inside trusted model execution.

encrypted_content: string

Opaque encrypted content.

maxLength10485760
type: "encrypted_content"

The type of the input item. Always encrypted_content.

recipient: string

The destination agent identity.

type: "agent_message"

The item type. Always agent_message.

id?: string | null

The unique ID of this agent message item.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

MultiAgentCall { action, arguments, call_id, 3 more }
action: "spawn_agent" | "interrupt_agent" | "list_agents" | 3 more

The multi-agent action that was executed.

One of the following:
"spawn_agent"
"interrupt_agent"
"list_agents"
"send_message"
"followup_task"
"wait_agent"
arguments: string

The action arguments as a JSON string.

call_id: string

The unique ID linking this call to its output.

minLength1
maxLength64
type: "multi_agent_call"

The item type. Always multi_agent_call.

id?: string | null

The unique ID of this multi-agent call.

agent?: Agent | null

The agent that produced this item.

agent_name: string

The canonical name of the agent that produced this item.

MultiAgentCallOutput { action, call_id, output, 3 more }
action: "spawn_agent" | "interrupt_agent" | "list_agents" | 3 more

The multi-agent action that produced this result.

One of the following:
"spawn_agent"
"interrupt_agent"
"list_agents"
"send_message"
"followup_task"
"wait_agent"
call_id: string

The unique ID of the multi-agent call.

minLength1
maxLength64
output: Array<Output>

Text output returned by the multi-agent action.

type: "multi_agent_call_output"

The item type. Always multi_agent_call_output.

id?: string | null

The unique ID of this multi-agent call output.

agent?: Agent | null

The agent that produced this item.

ToolSearchCall { arguments, type, id, 4 more }
BetaResponseToolSearchOutputItemParam { tools, type, id, 4 more }
AdditionalTools { role, tools, type, 2 more }
BetaResponseConfigurationUpdateItemParam { type, id, agent, reasoning }

An update to the conversation’s response configuration. The configuration remains in effect for subsequent responses until it is replaced by another configuration update.

BetaResponseReasoningItem { id, summary, type, 4 more }

A description of the chain of thought used by a reasoning model while generating a response. Be sure to include these items in your input to the Responses API for subsequent turns of a conversation if you are manually managing context.

BetaResponseCompactionItemParam { encrypted_content, type, id, agent }

A compaction item generated by the v1/responses/compact API.

ImageGenerationCall { id, result, status, 2 more }

An image generation request made by the model.

BetaResponseCodeInterpreterToolCall { id, code, container_id, 4 more }

A tool call to run code.

LocalShellCall { id, action, call_id, 3 more }

A tool call to run a command on the local shell.

LocalShellCallOutput { id, output, type, 2 more }

The output of a local shell tool call.

ShellCall { action, call_id, type, 5 more }

A tool representing a request to execute one or more shell commands.

ShellCallOutput { call_id, output, type, 5 more }

The streamed output items emitted by a shell tool call.

ApplyPatchCall { call_id, operation, status, 4 more }

A tool call representing a request to create, delete, or update files using diff patches.

ApplyPatchCallOutput { call_id, status, type, 4 more }

The streamed output emitted by an apply patch tool call.

McpListTools { id, server_label, tools, 3 more }

A list of tools available on an MCP server.

McpApprovalRequest { id, arguments, name, 3 more }

A request for human approval of a tool invocation.

McpApprovalResponse { approval_request_id, approve, type, 3 more }

A response to an MCP approval request.

McpCall { id, arguments, name, 7 more }

An invocation of a tool on an MCP server.

BetaResponseCustomToolCallOutput { call_id, output, type, 3 more }

The output of a custom tool call from your code, being sent back to the model.

BetaResponseCustomToolCall { call_id, input, name, 6 more }

A call to a custom tool created by the model.

CompactionTrigger { type, agent }

Compacts the current context. Must be the final input item.

ItemReference { id, agent, type }

An internal identifier for an item to reference.

Program { id, call_id, code, 3 more }
ProgramOutput { id, call_id, result, 3 more }
instructions?: string | null

Body param: A system (or developer) message inserted into the model’s context.

When using along with previous_response_id, the instructions from a previous response will not be carried over to the next response. This makes it simple to swap out system (or developer) messages in new responses.

max_output_tokens?: number | null

Body param: An upper bound for the number of tokens that can be generated for a response, including visible output tokens and reasoning tokens.

minimum16
max_tool_calls?: number | null

Body param: The maximum number of total calls to built-in tools that can be processed in a response. This maximum number applies across all built-in tool calls, not per individual tool. Any further attempts to call a tool by the model will be ignored.

metadata?: Record<string, string> | null

Body param: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model?: "gpt-6-astra" | "gpt-5.6-sol" | "gpt-5.6-terra" | 100 more | (string & {})

Body param: Model ID used to generate the response, like gpt-6-astra. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.

moderation?: Moderation | null

Body param: Configuration for running moderation on the input and output of this response.

multi_agent?: MultiAgent | null

Body param: Configuration for server-hosted multi-agent execution.

parallel_tool_calls?: boolean | null

Body param: Whether to allow the model to run tool calls in parallel.

previous_response_id?: string | null

Body param: The unique ID of the previous response to the model. Use this to create multi-turn conversations. Learn more about conversation state. Cannot be used in conjunction with conversation.

prompt?: BetaResponsePrompt { id, variables, version } | null

Body param: Reference to a prompt template and its variables. Learn more.

prompt_cache_key?: string | null

Body param: Used by OpenAI to cache responses for similar requests to optimize your cache hit rates. Replaces the user field. Learn more.

prompt_cache_options?: PromptCacheOptions

Body param: Options for prompt caching. Supported for gpt-5.6 and later models. By default, OpenAI automatically chooses one implicit cache breakpoint. You can add explicit breakpoints to content blocks with prompt_cache_breakpoint. Each request can write up to four breakpoints. For cache matching, OpenAI considers up to the latest 80 breakpoints in the conversation, without a content-block lookback limit. Set mode to explicit to disable the implicit breakpoint. The ttl defaults to 30m, which is currently the only supported value. See the prompt caching guide for current details.

Deprecatedprompt_cache_retention?: "in_memory" | "24h" | null

Body param: Deprecated. Use prompt_cache_options.ttl instead.

The retention policy for the prompt cache. Set to 24h to enable extended prompt caching, which keeps cached prefixes active for longer, up to a maximum of 24 hours. Learn more. This field expresses a maximum retention policy, while prompt_cache_options.ttl expresses a minimum cache lifetime. The two fields are independent and do not interact. For gpt-5.5, gpt-5.5-pro, and future models, only 24h is supported.

For older models that support both in_memory and 24h, the default depends on your organization’s data retention policy:

  • Organizations without ZDR enabled default to 24h.
  • Organizations with ZDR enabled default to in_memory when prompt_cache_retention is not specified.
reasoning?: Reasoning | null

Body param: Configuration options for reasoning models.

safety_identifier?: string | null

Body param: A stable identifier used to help detect users of your application that may be violating OpenAI’s usage policies. The IDs should be a string that uniquely identifies each user, with a maximum length of 64 characters. We recommend hashing their username or email address, in order to avoid sending us any identifying information. Learn more.

maxLength64
service_tier?: BetaServiceTier | null

Body param: Specifies the processing type used for serving the request.

  • If set to ‘auto’, then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use ‘default’.
  • If set to ‘default’, then the request will be processed with the standard pricing and performance for the selected model.
  • If set to ‘flex’, then the request will be processed with the Flex Processing service tier.
  • To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request.
  • If set to ‘ultrafast’, then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast.
  • When not set, the default behavior is ‘auto’.

When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

store?: boolean | null

Body param: Whether to store the generated model response for later retrieval via API. Defaults to true when omitted. If set to true, response data will be stored for at least 30 days, subject to the data retention exceptions.

stream?: false | null

Body param: If set to true, the model response data will be streamed to the client as it is generated using server-sent events. See the Streaming section below for more information.

stream_options?: StreamOptions | null

Body param: Options for streaming responses. Only set this when you set stream: true.

temperature?: number | null

Body param: What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both.

minimum0
maximum2
text?: BetaResponseTextConfig { format, verbosity }

Body param: Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more:

tool_choice?: BetaToolChoiceOptions | BetaToolChoiceAllowed { mode, tools, type } | BetaToolChoiceTypes { type } | 6 more

Body param: How the model should select which tool (or tools) to use when generating a response. See the tools parameter to see how to specify which tools the model can call.

tools?: Array<BetaTool>

Body param: An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter.

We support the following categories of tools:

  • Built-in tools: Tools that are provided by OpenAI that extend the model’s capabilities, like web search or file search. Learn more about built-in tools.
  • MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools.
  • Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.
top_logprobs?: number | null

Body param: An integer between 0 and 20 specifying the maximum number of most likely tokens to return at each token position, each with an associated log probability. In some cases, the number of returned tokens may be fewer than requested.

minimum0
maximum20
top_p?: number | null

Body param: An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

We generally recommend altering this or temperature but not both.

minimum0
maximum1
Deprecatedtruncation?: "auto" | "disabled" | null

Body param: The truncation strategy to use for the model response.

  • auto: If the input to this Response exceeds the model’s context window size, the model will truncate the response to fit the context window by dropping items from the beginning of the conversation.
  • disabled (default): If the input size will exceed the context window size for a model, the request will fail with a 400 error.
Deprecateduser?: string

Body param: This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.

betas?: Array<"responses_multi_agent=v1">

Header param: Optional beta features to enable for this request.